﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Common;

namespace HeuristicLab.Problems.MetaOptimization {
  [StorableClass]
  public class NullValueConfiguration : ValueConfiguration {

    public NullValueConfiguration() {
      this.ParameterConfigurations = new ItemList<IParameterConfiguration>();
      this.ActualValue = new ConstrainedValue(null, null, null, true);
      this.IsOptimizable = false;
    }
    [StorableConstructor]
    protected NullValueConfiguration(bool deserializing) : base(deserializing) { }
    protected NullValueConfiguration(NullValueConfiguration original, Cloner cloner)
      : base(original, cloner) {
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new NullValueConfiguration(this, cloner);
    }

    public override string ToString() {
      return "null";
    }
  }
}
